grammar JavaMethods;

methods : (method)+                                                         #MethodsNode
        ;                                                 

method : return_type method_name '(' parameters ')' exceptions ';'          #MethodNode
       ;

return_type : type                                                          #ReturnTypeNode
            ;

type : object_type                                                          #ObjectTypeNode
     | array_type                                                           #ArrayTypeNode
     ;
 
parameters :                                                                #EmptyParametersNode
           | (parameter)+ (',' parameter)*                                  #ParametersNode
           ;

parameter : type parameter_name                                             #ParameterNode
          ;

exceptions :                                                                #EmptyExceptionsNode
           | 'throws' (exception)+ (',' exception)*                         #ExceptionsNode
           ;

exception : object_type                                                     #ExceptionNode
          ;

method_name : VALUE                                                         #MethodNameNode
            ;

parameter_name : VALUE                                                      #ParameterNameNode
            ;

object_type : VALUE                                                         #ObjectTypeValueNode
            ;

array_type : VALUE ('[' ']')+                                               #ArrayTypeValueNode
           ;

VALUE : [_a-zA-Z]+[_a-zA-Z0-9]* ;
WS : [ \t\r\n]+ -> skip ;