package antlr4_parser;

import org.antlr.v4.runtime.tree.*;
import org.antlr.v4.runtime.Token;

public interface JavaMethodsListener extends ParseTreeListener {
	void enterArrayTypeValueNode(JavaMethodsParser.ArrayTypeValueNodeContext ctx);
	void exitArrayTypeValueNode(JavaMethodsParser.ArrayTypeValueNodeContext ctx);

	void enterParametersNode(JavaMethodsParser.ParametersNodeContext ctx);
	void exitParametersNode(JavaMethodsParser.ParametersNodeContext ctx);

	void enterExceptionNode(JavaMethodsParser.ExceptionNodeContext ctx);
	void exitExceptionNode(JavaMethodsParser.ExceptionNodeContext ctx);

	void enterObjectTypeValueNode(JavaMethodsParser.ObjectTypeValueNodeContext ctx);
	void exitObjectTypeValueNode(JavaMethodsParser.ObjectTypeValueNodeContext ctx);

	void enterMethodNode(JavaMethodsParser.MethodNodeContext ctx);
	void exitMethodNode(JavaMethodsParser.MethodNodeContext ctx);

	void enterParameterNode(JavaMethodsParser.ParameterNodeContext ctx);
	void exitParameterNode(JavaMethodsParser.ParameterNodeContext ctx);

	void enterArrayTypeNode(JavaMethodsParser.ArrayTypeNodeContext ctx);
	void exitArrayTypeNode(JavaMethodsParser.ArrayTypeNodeContext ctx);

	void enterEmptyExceptionsNode(JavaMethodsParser.EmptyExceptionsNodeContext ctx);
	void exitEmptyExceptionsNode(JavaMethodsParser.EmptyExceptionsNodeContext ctx);

	void enterExceptionsNode(JavaMethodsParser.ExceptionsNodeContext ctx);
	void exitExceptionsNode(JavaMethodsParser.ExceptionsNodeContext ctx);

	void enterParameterNameNode(JavaMethodsParser.ParameterNameNodeContext ctx);
	void exitParameterNameNode(JavaMethodsParser.ParameterNameNodeContext ctx);

	void enterMethodsNode(JavaMethodsParser.MethodsNodeContext ctx);
	void exitMethodsNode(JavaMethodsParser.MethodsNodeContext ctx);

	void enterMethodNameNode(JavaMethodsParser.MethodNameNodeContext ctx);
	void exitMethodNameNode(JavaMethodsParser.MethodNameNodeContext ctx);

	void enterEmptyParametersNode(JavaMethodsParser.EmptyParametersNodeContext ctx);
	void exitEmptyParametersNode(JavaMethodsParser.EmptyParametersNodeContext ctx);

	void enterObjectTypeNode(JavaMethodsParser.ObjectTypeNodeContext ctx);
	void exitObjectTypeNode(JavaMethodsParser.ObjectTypeNodeContext ctx);

	void enterReturnTypeNode(JavaMethodsParser.ReturnTypeNodeContext ctx);
	void exitReturnTypeNode(JavaMethodsParser.ReturnTypeNodeContext ctx);
}