package antlr4_parser;

import org.antlr.v4.runtime.atn.*;
import org.antlr.v4.runtime.dfa.DFA;
import org.antlr.v4.runtime.*;
import org.antlr.v4.runtime.misc.*;
import org.antlr.v4.runtime.tree.*;
import java.util.List;
import java.util.Iterator;
import java.util.ArrayList;

@SuppressWarnings({"all", "warnings", "unchecked", "unused", "cast"})
public class JavaMethodsParser extends Parser {
	protected static final DFA[] _decisionToDFA;
	protected static final PredictionContextCache _sharedContextCache =
		new PredictionContextCache();
	public static final int
		T__6=1, T__5=2, T__4=3, T__3=4, T__2=5, T__1=6, T__0=7, VALUE=8, WS=9;
	public static final String[] tokenNames = {
		"<INVALID>", "']'", "')'", "'throws'", "','", "'['", "'('", "';'", "VALUE", 
		"WS"
	};
	public static final int
		RULE_methods = 0, RULE_method = 1, RULE_return_type = 2, RULE_type = 3, 
		RULE_parameters = 4, RULE_parameter = 5, RULE_exceptions = 6, RULE_exception = 7, 
		RULE_method_name = 8, RULE_parameter_name = 9, RULE_object_type = 10, 
		RULE_array_type = 11;
	public static final String[] ruleNames = {
		"methods", "method", "return_type", "type", "parameters", "parameter", 
		"exceptions", "exception", "method_name", "parameter_name", "object_type", 
		"array_type"
	};

	@Override
	public String getGrammarFileName() { return "JavaMethods.g4"; }

	@Override
	public String[] getTokenNames() { return tokenNames; }

	@Override
	public String[] getRuleNames() { return ruleNames; }

	@Override
	public ATN getATN() { return _ATN; }

	public JavaMethodsParser(TokenStream input) {
		super(input);
		_interp = new ParserATNSimulator(this,_ATN,_decisionToDFA,_sharedContextCache);
	}
	public static class MethodsContext extends ParserRuleContext {
		public MethodsContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_methods; }
	 
		public MethodsContext() { }
		public void copyFrom(MethodsContext ctx) {
			super.copyFrom(ctx);
		}
	}
	public static class MethodsNodeContext extends MethodsContext {
		public MethodContext method(int i) {
			return getRuleContext(MethodContext.class,i);
		}
		public List<MethodContext> method() {
			return getRuleContexts(MethodContext.class);
		}
		public MethodsNodeContext(MethodsContext ctx) { copyFrom(ctx); }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).enterMethodsNode(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).exitMethodsNode(this);
		}
		@Override
		public <T> T accept(ParseTreeVisitor<? extends T> visitor) {
			if ( visitor instanceof JavaMethodsVisitor ) return ((JavaMethodsVisitor<? extends T>)visitor).visitMethodsNode(this);
			else return visitor.visitChildren(this);
		}
	}

	public final MethodsContext methods() throws RecognitionException {
		MethodsContext _localctx = new MethodsContext(_ctx, getState());
		enterRule(_localctx, 0, RULE_methods);
		int _la;
		try {
			_localctx = new MethodsNodeContext(_localctx);
			enterOuterAlt(_localctx, 1);
			{
			setState(25); 
			_errHandler.sync(this);
			_la = _input.LA(1);
			do {
				{
				{
				setState(24); method();
				}
				}
				setState(27); 
				_errHandler.sync(this);
				_la = _input.LA(1);
			} while ( _la==VALUE );
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class MethodContext extends ParserRuleContext {
		public MethodContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_method; }
	 
		public MethodContext() { }
		public void copyFrom(MethodContext ctx) {
			super.copyFrom(ctx);
		}
	}
	public static class MethodNodeContext extends MethodContext {
		public ExceptionsContext exceptions() {
			return getRuleContext(ExceptionsContext.class,0);
		}
		public Method_nameContext method_name() {
			return getRuleContext(Method_nameContext.class,0);
		}
		public ParametersContext parameters() {
			return getRuleContext(ParametersContext.class,0);
		}
		public Return_typeContext return_type() {
			return getRuleContext(Return_typeContext.class,0);
		}
		public MethodNodeContext(MethodContext ctx) { copyFrom(ctx); }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).enterMethodNode(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).exitMethodNode(this);
		}
		@Override
		public <T> T accept(ParseTreeVisitor<? extends T> visitor) {
			if ( visitor instanceof JavaMethodsVisitor ) return ((JavaMethodsVisitor<? extends T>)visitor).visitMethodNode(this);
			else return visitor.visitChildren(this);
		}
	}

	public final MethodContext method() throws RecognitionException {
		MethodContext _localctx = new MethodContext(_ctx, getState());
		enterRule(_localctx, 2, RULE_method);
		try {
			_localctx = new MethodNodeContext(_localctx);
			enterOuterAlt(_localctx, 1);
			{
			setState(29); return_type();
			setState(30); method_name();
			setState(31); match(6);
			setState(32); parameters();
			setState(33); match(2);
			setState(34); exceptions();
			setState(35); match(7);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class Return_typeContext extends ParserRuleContext {
		public Return_typeContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_return_type; }
	 
		public Return_typeContext() { }
		public void copyFrom(Return_typeContext ctx) {
			super.copyFrom(ctx);
		}
	}
	public static class ReturnTypeNodeContext extends Return_typeContext {
		public TypeContext type() {
			return getRuleContext(TypeContext.class,0);
		}
		public ReturnTypeNodeContext(Return_typeContext ctx) { copyFrom(ctx); }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).enterReturnTypeNode(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).exitReturnTypeNode(this);
		}
		@Override
		public <T> T accept(ParseTreeVisitor<? extends T> visitor) {
			if ( visitor instanceof JavaMethodsVisitor ) return ((JavaMethodsVisitor<? extends T>)visitor).visitReturnTypeNode(this);
			else return visitor.visitChildren(this);
		}
	}

	public final Return_typeContext return_type() throws RecognitionException {
		Return_typeContext _localctx = new Return_typeContext(_ctx, getState());
		enterRule(_localctx, 4, RULE_return_type);
		try {
			_localctx = new ReturnTypeNodeContext(_localctx);
			enterOuterAlt(_localctx, 1);
			{
			setState(37); type();
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class TypeContext extends ParserRuleContext {
		public TypeContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_type; }
	 
		public TypeContext() { }
		public void copyFrom(TypeContext ctx) {
			super.copyFrom(ctx);
		}
	}
	public static class ArrayTypeNodeContext extends TypeContext {
		public Array_typeContext array_type() {
			return getRuleContext(Array_typeContext.class,0);
		}
		public ArrayTypeNodeContext(TypeContext ctx) { copyFrom(ctx); }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).enterArrayTypeNode(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).exitArrayTypeNode(this);
		}
		@Override
		public <T> T accept(ParseTreeVisitor<? extends T> visitor) {
			if ( visitor instanceof JavaMethodsVisitor ) return ((JavaMethodsVisitor<? extends T>)visitor).visitArrayTypeNode(this);
			else return visitor.visitChildren(this);
		}
	}
	public static class ObjectTypeNodeContext extends TypeContext {
		public Object_typeContext object_type() {
			return getRuleContext(Object_typeContext.class,0);
		}
		public ObjectTypeNodeContext(TypeContext ctx) { copyFrom(ctx); }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).enterObjectTypeNode(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).exitObjectTypeNode(this);
		}
		@Override
		public <T> T accept(ParseTreeVisitor<? extends T> visitor) {
			if ( visitor instanceof JavaMethodsVisitor ) return ((JavaMethodsVisitor<? extends T>)visitor).visitObjectTypeNode(this);
			else return visitor.visitChildren(this);
		}
	}

	public final TypeContext type() throws RecognitionException {
		TypeContext _localctx = new TypeContext(_ctx, getState());
		enterRule(_localctx, 6, RULE_type);
		try {
			setState(41);
			switch ( getInterpreter().adaptivePredict(_input,1,_ctx) ) {
			case 1:
				_localctx = new ObjectTypeNodeContext(_localctx);
				enterOuterAlt(_localctx, 1);
				{
				setState(39); object_type();
				}
				break;

			case 2:
				_localctx = new ArrayTypeNodeContext(_localctx);
				enterOuterAlt(_localctx, 2);
				{
				setState(40); array_type();
				}
				break;
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class ParametersContext extends ParserRuleContext {
		public ParametersContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_parameters; }
	 
		public ParametersContext() { }
		public void copyFrom(ParametersContext ctx) {
			super.copyFrom(ctx);
		}
	}
	public static class ParametersNodeContext extends ParametersContext {
		public ParameterContext parameter(int i) {
			return getRuleContext(ParameterContext.class,i);
		}
		public List<ParameterContext> parameter() {
			return getRuleContexts(ParameterContext.class);
		}
		public ParametersNodeContext(ParametersContext ctx) { copyFrom(ctx); }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).enterParametersNode(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).exitParametersNode(this);
		}
		@Override
		public <T> T accept(ParseTreeVisitor<? extends T> visitor) {
			if ( visitor instanceof JavaMethodsVisitor ) return ((JavaMethodsVisitor<? extends T>)visitor).visitParametersNode(this);
			else return visitor.visitChildren(this);
		}
	}
	public static class EmptyParametersNodeContext extends ParametersContext {
		public EmptyParametersNodeContext(ParametersContext ctx) { copyFrom(ctx); }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).enterEmptyParametersNode(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).exitEmptyParametersNode(this);
		}
		@Override
		public <T> T accept(ParseTreeVisitor<? extends T> visitor) {
			if ( visitor instanceof JavaMethodsVisitor ) return ((JavaMethodsVisitor<? extends T>)visitor).visitEmptyParametersNode(this);
			else return visitor.visitChildren(this);
		}
	}

	public final ParametersContext parameters() throws RecognitionException {
		ParametersContext _localctx = new ParametersContext(_ctx, getState());
		enterRule(_localctx, 8, RULE_parameters);
		int _la;
		try {
			setState(56);
			switch (_input.LA(1)) {
			case 2:
				_localctx = new EmptyParametersNodeContext(_localctx);
				enterOuterAlt(_localctx, 1);
				{
				}
				break;
			case VALUE:
				_localctx = new ParametersNodeContext(_localctx);
				enterOuterAlt(_localctx, 2);
				{
				setState(45); 
				_errHandler.sync(this);
				_la = _input.LA(1);
				do {
					{
					{
					setState(44); parameter();
					}
					}
					setState(47); 
					_errHandler.sync(this);
					_la = _input.LA(1);
				} while ( _la==VALUE );
				setState(53);
				_errHandler.sync(this);
				_la = _input.LA(1);
				while (_la==4) {
					{
					{
					setState(49); match(4);
					setState(50); parameter();
					}
					}
					setState(55);
					_errHandler.sync(this);
					_la = _input.LA(1);
				}
				}
				break;
			default:
				throw new NoViableAltException(this);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class ParameterContext extends ParserRuleContext {
		public ParameterContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_parameter; }
	 
		public ParameterContext() { }
		public void copyFrom(ParameterContext ctx) {
			super.copyFrom(ctx);
		}
	}
	public static class ParameterNodeContext extends ParameterContext {
		public Parameter_nameContext parameter_name() {
			return getRuleContext(Parameter_nameContext.class,0);
		}
		public TypeContext type() {
			return getRuleContext(TypeContext.class,0);
		}
		public ParameterNodeContext(ParameterContext ctx) { copyFrom(ctx); }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).enterParameterNode(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).exitParameterNode(this);
		}
		@Override
		public <T> T accept(ParseTreeVisitor<? extends T> visitor) {
			if ( visitor instanceof JavaMethodsVisitor ) return ((JavaMethodsVisitor<? extends T>)visitor).visitParameterNode(this);
			else return visitor.visitChildren(this);
		}
	}

	public final ParameterContext parameter() throws RecognitionException {
		ParameterContext _localctx = new ParameterContext(_ctx, getState());
		enterRule(_localctx, 10, RULE_parameter);
		try {
			_localctx = new ParameterNodeContext(_localctx);
			enterOuterAlt(_localctx, 1);
			{
			setState(58); type();
			setState(59); parameter_name();
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class ExceptionsContext extends ParserRuleContext {
		public ExceptionsContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_exceptions; }
	 
		public ExceptionsContext() { }
		public void copyFrom(ExceptionsContext ctx) {
			super.copyFrom(ctx);
		}
	}
	public static class EmptyExceptionsNodeContext extends ExceptionsContext {
		public EmptyExceptionsNodeContext(ExceptionsContext ctx) { copyFrom(ctx); }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).enterEmptyExceptionsNode(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).exitEmptyExceptionsNode(this);
		}
		@Override
		public <T> T accept(ParseTreeVisitor<? extends T> visitor) {
			if ( visitor instanceof JavaMethodsVisitor ) return ((JavaMethodsVisitor<? extends T>)visitor).visitEmptyExceptionsNode(this);
			else return visitor.visitChildren(this);
		}
	}
	public static class ExceptionsNodeContext extends ExceptionsContext {
		public ExceptionContext exception(int i) {
			return getRuleContext(ExceptionContext.class,i);
		}
		public List<ExceptionContext> exception() {
			return getRuleContexts(ExceptionContext.class);
		}
		public ExceptionsNodeContext(ExceptionsContext ctx) { copyFrom(ctx); }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).enterExceptionsNode(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).exitExceptionsNode(this);
		}
		@Override
		public <T> T accept(ParseTreeVisitor<? extends T> visitor) {
			if ( visitor instanceof JavaMethodsVisitor ) return ((JavaMethodsVisitor<? extends T>)visitor).visitExceptionsNode(this);
			else return visitor.visitChildren(this);
		}
	}

	public final ExceptionsContext exceptions() throws RecognitionException {
		ExceptionsContext _localctx = new ExceptionsContext(_ctx, getState());
		enterRule(_localctx, 12, RULE_exceptions);
		int _la;
		try {
			setState(75);
			switch (_input.LA(1)) {
			case 7:
				_localctx = new EmptyExceptionsNodeContext(_localctx);
				enterOuterAlt(_localctx, 1);
				{
				}
				break;
			case 3:
				_localctx = new ExceptionsNodeContext(_localctx);
				enterOuterAlt(_localctx, 2);
				{
				setState(62); match(3);
				setState(64); 
				_errHandler.sync(this);
				_la = _input.LA(1);
				do {
					{
					{
					setState(63); exception();
					}
					}
					setState(66); 
					_errHandler.sync(this);
					_la = _input.LA(1);
				} while ( _la==VALUE );
				setState(72);
				_errHandler.sync(this);
				_la = _input.LA(1);
				while (_la==4) {
					{
					{
					setState(68); match(4);
					setState(69); exception();
					}
					}
					setState(74);
					_errHandler.sync(this);
					_la = _input.LA(1);
				}
				}
				break;
			default:
				throw new NoViableAltException(this);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class ExceptionContext extends ParserRuleContext {
		public ExceptionContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_exception; }
	 
		public ExceptionContext() { }
		public void copyFrom(ExceptionContext ctx) {
			super.copyFrom(ctx);
		}
	}
	public static class ExceptionNodeContext extends ExceptionContext {
		public Object_typeContext object_type() {
			return getRuleContext(Object_typeContext.class,0);
		}
		public ExceptionNodeContext(ExceptionContext ctx) { copyFrom(ctx); }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).enterExceptionNode(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).exitExceptionNode(this);
		}
		@Override
		public <T> T accept(ParseTreeVisitor<? extends T> visitor) {
			if ( visitor instanceof JavaMethodsVisitor ) return ((JavaMethodsVisitor<? extends T>)visitor).visitExceptionNode(this);
			else return visitor.visitChildren(this);
		}
	}

	public final ExceptionContext exception() throws RecognitionException {
		ExceptionContext _localctx = new ExceptionContext(_ctx, getState());
		enterRule(_localctx, 14, RULE_exception);
		try {
			_localctx = new ExceptionNodeContext(_localctx);
			enterOuterAlt(_localctx, 1);
			{
			setState(77); object_type();
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class Method_nameContext extends ParserRuleContext {
		public Method_nameContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_method_name; }
	 
		public Method_nameContext() { }
		public void copyFrom(Method_nameContext ctx) {
			super.copyFrom(ctx);
		}
	}
	public static class MethodNameNodeContext extends Method_nameContext {
		public TerminalNode VALUE() { return getToken(JavaMethodsParser.VALUE, 0); }
		public MethodNameNodeContext(Method_nameContext ctx) { copyFrom(ctx); }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).enterMethodNameNode(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).exitMethodNameNode(this);
		}
		@Override
		public <T> T accept(ParseTreeVisitor<? extends T> visitor) {
			if ( visitor instanceof JavaMethodsVisitor ) return ((JavaMethodsVisitor<? extends T>)visitor).visitMethodNameNode(this);
			else return visitor.visitChildren(this);
		}
	}

	public final Method_nameContext method_name() throws RecognitionException {
		Method_nameContext _localctx = new Method_nameContext(_ctx, getState());
		enterRule(_localctx, 16, RULE_method_name);
		try {
			_localctx = new MethodNameNodeContext(_localctx);
			enterOuterAlt(_localctx, 1);
			{
			setState(79); match(VALUE);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class Parameter_nameContext extends ParserRuleContext {
		public Parameter_nameContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_parameter_name; }
	 
		public Parameter_nameContext() { }
		public void copyFrom(Parameter_nameContext ctx) {
			super.copyFrom(ctx);
		}
	}
	public static class ParameterNameNodeContext extends Parameter_nameContext {
		public TerminalNode VALUE() { return getToken(JavaMethodsParser.VALUE, 0); }
		public ParameterNameNodeContext(Parameter_nameContext ctx) { copyFrom(ctx); }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).enterParameterNameNode(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).exitParameterNameNode(this);
		}
		@Override
		public <T> T accept(ParseTreeVisitor<? extends T> visitor) {
			if ( visitor instanceof JavaMethodsVisitor ) return ((JavaMethodsVisitor<? extends T>)visitor).visitParameterNameNode(this);
			else return visitor.visitChildren(this);
		}
	}

	public final Parameter_nameContext parameter_name() throws RecognitionException {
		Parameter_nameContext _localctx = new Parameter_nameContext(_ctx, getState());
		enterRule(_localctx, 18, RULE_parameter_name);
		try {
			_localctx = new ParameterNameNodeContext(_localctx);
			enterOuterAlt(_localctx, 1);
			{
			setState(81); match(VALUE);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class Object_typeContext extends ParserRuleContext {
		public Object_typeContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_object_type; }
	 
		public Object_typeContext() { }
		public void copyFrom(Object_typeContext ctx) {
			super.copyFrom(ctx);
		}
	}
	public static class ObjectTypeValueNodeContext extends Object_typeContext {
		public TerminalNode VALUE() { return getToken(JavaMethodsParser.VALUE, 0); }
		public ObjectTypeValueNodeContext(Object_typeContext ctx) { copyFrom(ctx); }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).enterObjectTypeValueNode(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).exitObjectTypeValueNode(this);
		}
		@Override
		public <T> T accept(ParseTreeVisitor<? extends T> visitor) {
			if ( visitor instanceof JavaMethodsVisitor ) return ((JavaMethodsVisitor<? extends T>)visitor).visitObjectTypeValueNode(this);
			else return visitor.visitChildren(this);
		}
	}

	public final Object_typeContext object_type() throws RecognitionException {
		Object_typeContext _localctx = new Object_typeContext(_ctx, getState());
		enterRule(_localctx, 20, RULE_object_type);
		try {
			_localctx = new ObjectTypeValueNodeContext(_localctx);
			enterOuterAlt(_localctx, 1);
			{
			setState(83); match(VALUE);
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static class Array_typeContext extends ParserRuleContext {
		public Array_typeContext(ParserRuleContext parent, int invokingState) {
			super(parent, invokingState);
		}
		@Override public int getRuleIndex() { return RULE_array_type; }
	 
		public Array_typeContext() { }
		public void copyFrom(Array_typeContext ctx) {
			super.copyFrom(ctx);
		}
	}
	public static class ArrayTypeValueNodeContext extends Array_typeContext {
		public TerminalNode VALUE() { return getToken(JavaMethodsParser.VALUE, 0); }
		public ArrayTypeValueNodeContext(Array_typeContext ctx) { copyFrom(ctx); }
		@Override
		public void enterRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).enterArrayTypeValueNode(this);
		}
		@Override
		public void exitRule(ParseTreeListener listener) {
			if ( listener instanceof JavaMethodsListener ) ((JavaMethodsListener)listener).exitArrayTypeValueNode(this);
		}
		@Override
		public <T> T accept(ParseTreeVisitor<? extends T> visitor) {
			if ( visitor instanceof JavaMethodsVisitor ) return ((JavaMethodsVisitor<? extends T>)visitor).visitArrayTypeValueNode(this);
			else return visitor.visitChildren(this);
		}
	}

	public final Array_typeContext array_type() throws RecognitionException {
		Array_typeContext _localctx = new Array_typeContext(_ctx, getState());
		enterRule(_localctx, 22, RULE_array_type);
		int _la;
		try {
			_localctx = new ArrayTypeValueNodeContext(_localctx);
			enterOuterAlt(_localctx, 1);
			{
			setState(85); match(VALUE);
			setState(88); 
			_errHandler.sync(this);
			_la = _input.LA(1);
			do {
				{
				{
				setState(86); match(5);
				setState(87); match(1);
				}
				}
				setState(90); 
				_errHandler.sync(this);
				_la = _input.LA(1);
			} while ( _la==5 );
			}
		}
		catch (RecognitionException re) {
			_localctx.exception = re;
			_errHandler.reportError(this, re);
			_errHandler.recover(this, re);
		}
		finally {
			exitRule();
		}
		return _localctx;
	}

	public static final String _serializedATN =
		"\2\3\13_\4\2\t\2\4\3\t\3\4\4\t\4\4\5\t\5\4\6\t\6\4\7\t\7\4\b\t\b\4\t\t"+
		"\t\4\n\t\n\4\13\t\13\4\f\t\f\4\r\t\r\3\2\6\2\34\n\2\r\2\16\2\35\3\3\3"+
		"\3\3\3\3\3\3\3\3\3\3\3\3\3\3\4\3\4\3\5\3\5\5\5,\n\5\3\6\3\6\6\6\60\n\6"+
		"\r\6\16\6\61\3\6\3\6\7\6\66\n\6\f\6\16\69\13\6\5\6;\n\6\3\7\3\7\3\7\3"+
		"\b\3\b\3\b\6\bC\n\b\r\b\16\bD\3\b\3\b\7\bI\n\b\f\b\16\bL\13\b\5\bN\n\b"+
		"\3\t\3\t\3\n\3\n\3\13\3\13\3\f\3\f\3\r\3\r\3\r\6\r[\n\r\r\r\16\r\\\3\r"+
		"\2\16\2\4\6\b\n\f\16\20\22\24\26\30\2\2[\2\33\3\2\2\2\4\37\3\2\2\2\6\'"+
		"\3\2\2\2\b+\3\2\2\2\n:\3\2\2\2\f<\3\2\2\2\16M\3\2\2\2\20O\3\2\2\2\22Q"+
		"\3\2\2\2\24S\3\2\2\2\26U\3\2\2\2\30W\3\2\2\2\32\34\5\4\3\2\33\32\3\2\2"+
		"\2\34\35\3\2\2\2\35\33\3\2\2\2\35\36\3\2\2\2\36\3\3\2\2\2\37 \5\6\4\2"+
		" !\5\22\n\2!\"\7\b\2\2\"#\5\n\6\2#$\7\4\2\2$%\5\16\b\2%&\7\t\2\2&\5\3"+
		"\2\2\2\'(\5\b\5\2(\7\3\2\2\2),\5\26\f\2*,\5\30\r\2+)\3\2\2\2+*\3\2\2\2"+
		",\t\3\2\2\2-;\3\2\2\2.\60\5\f\7\2/.\3\2\2\2\60\61\3\2\2\2\61/\3\2\2\2"+
		"\61\62\3\2\2\2\62\67\3\2\2\2\63\64\7\6\2\2\64\66\5\f\7\2\65\63\3\2\2\2"+
		"\669\3\2\2\2\67\65\3\2\2\2\678\3\2\2\28;\3\2\2\29\67\3\2\2\2:-\3\2\2\2"+
		":/\3\2\2\2;\13\3\2\2\2<=\5\b\5\2=>\5\24\13\2>\r\3\2\2\2?N\3\2\2\2@B\7"+
		"\5\2\2AC\5\20\t\2BA\3\2\2\2CD\3\2\2\2DB\3\2\2\2DE\3\2\2\2EJ\3\2\2\2FG"+
		"\7\6\2\2GI\5\20\t\2HF\3\2\2\2IL\3\2\2\2JH\3\2\2\2JK\3\2\2\2KN\3\2\2\2"+
		"LJ\3\2\2\2M?\3\2\2\2M@\3\2\2\2N\17\3\2\2\2OP\5\26\f\2P\21\3\2\2\2QR\7"+
		"\n\2\2R\23\3\2\2\2ST\7\n\2\2T\25\3\2\2\2UV\7\n\2\2V\27\3\2\2\2WZ\7\n\2"+
		"\2XY\7\7\2\2Y[\7\3\2\2ZX\3\2\2\2[\\\3\2\2\2\\Z\3\2\2\2\\]\3\2\2\2]\31"+
		"\3\2\2\2\13\35+\61\67:DJM\\";
	public static final ATN _ATN =
		ATNSimulator.deserialize(_serializedATN.toCharArray());
	static {
		_decisionToDFA = new DFA[_ATN.getNumberOfDecisions()];
	}
}