package antlr4_parser;

import org.antlr.v4.runtime.tree.*;
import org.antlr.v4.runtime.Token;

public interface JavaMethodsVisitor<T> extends ParseTreeVisitor<T> {
	T visitArrayTypeValueNode(JavaMethodsParser.ArrayTypeValueNodeContext ctx);

	T visitParametersNode(JavaMethodsParser.ParametersNodeContext ctx);

	T visitExceptionNode(JavaMethodsParser.ExceptionNodeContext ctx);

	T visitObjectTypeValueNode(JavaMethodsParser.ObjectTypeValueNodeContext ctx);

	T visitMethodNode(JavaMethodsParser.MethodNodeContext ctx);

	T visitParameterNode(JavaMethodsParser.ParameterNodeContext ctx);

	T visitArrayTypeNode(JavaMethodsParser.ArrayTypeNodeContext ctx);

	T visitEmptyExceptionsNode(JavaMethodsParser.EmptyExceptionsNodeContext ctx);

	T visitExceptionsNode(JavaMethodsParser.ExceptionsNodeContext ctx);

	T visitParameterNameNode(JavaMethodsParser.ParameterNameNodeContext ctx);

	T visitMethodsNode(JavaMethodsParser.MethodsNodeContext ctx);

	T visitMethodNameNode(JavaMethodsParser.MethodNameNodeContext ctx);

	T visitEmptyParametersNode(JavaMethodsParser.EmptyParametersNodeContext ctx);

	T visitObjectTypeNode(JavaMethodsParser.ObjectTypeNodeContext ctx);

	T visitReturnTypeNode(JavaMethodsParser.ReturnTypeNodeContext ctx);
}