package antlr4_parser;

import java.util.ArrayList;
import java.util.List;

public class MethodData {
  private String returnType;
  private String name;
  private List<String> parameters = new ArrayList<String>();
  private List<String> exceptions = new ArrayList<String>();
  
	public String getReturnType() {
		return returnType;
	}
	
	public void setReturnType(String returnType) {
		this.returnType = returnType;
	}
	
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	
	public List<String> getParameters() {
		return parameters;
	}
	
	public void setParameters(List<String> parameters) {
		this.parameters = parameters;
	}
	
	public void addParameter(String parameter) {
		this.parameters.add(parameter);
	}
	
	public List<String> getExceptions() {
		return exceptions;
	}
	
	public void setExceptions(List<String> exceptions) {
		this.exceptions = exceptions;
	}
	
	public void addException(String exception) {
		exceptions.add(exception);
	}
	
	public String toString() {
		String stringMethod = "";
		stringMethod += returnType + " ";
		stringMethod += name + " ( ";
		
		if(parameters.size() > 0) {
			for(String s : parameters)
				stringMethod += s + ", ";
			stringMethod = stringMethod.substring(0, stringMethod.length() - 2) + " ) ";
		}
		else
			stringMethod += ") ";
			
		if(exceptions.size() > 0) {
			stringMethod += "throws ";
			for(String s : exceptions)
				stringMethod += s + ", ";
			stringMethod = stringMethod.substring(0, stringMethod.length() - 2) + " ;";
		}
		else
		  stringMethod += ";";
		return stringMethod;
	}
  
}
