package antlr4_parser;

public class SignatureVisitor extends JavaMethodsBaseVisitor<String> {
	private String signature;
	private String signatures;
	
	public SignatureVisitor() {
		this.signature = "";
		this.signatures = "";
	}
	
	@Override 
	public String visitMethodsNode(JavaMethodsParser.MethodsNodeContext ctx) { 
		for(int i = 0; i < ctx.getChildCount(); i++) {
		  visit(ctx.method(i));
		  signatures += signature + ';';
		  signature = "";
		}
		return signatures; 
  }
	
	@Override 
	public String visitMethodNode(JavaMethodsParser.MethodNodeContext ctx) { 
		visitChildren(ctx);
		return signature; 
  }
	
	@Override 
	public String visitMethodNameNode(JavaMethodsParser.MethodNameNodeContext ctx) { 
		signature += ctx.getText();
		return visitChildren(ctx); 
	}
	
	@Override 
	public String visitParameterNode(JavaMethodsParser.ParameterNodeContext ctx) { 
		String parameterType = visit(ctx.type());
		signature += "_" + parameterType;
		return parameterType; 
	}
	
	@Override 
	public String visitObjectTypeNode(JavaMethodsParser.ObjectTypeNodeContext ctx) {
		return ctx.getText();
	}
	
	@Override 
	public String visitArrayTypeNode(JavaMethodsParser.ArrayTypeNodeContext ctx) { 
		return ctx.getText();
	}

}
