package nl.uva.psy.swi.beangenerator;

import edu.stanford.smi.protege.model.Project;
import edu.stanford.smi.protege.plugin.PluginUtilities;
import edu.stanford.smi.protege.util.Log;
import edu.stanford.smi.protege.util.WaitCursor;
import gui.JavaMethodMapperPanel;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.FocusAdapter;
import java.awt.event.FocusEvent;
import java.awt.event.ItemListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Properties;
import java.util.logging.Logger;

import javax.swing.BorderFactory;
import javax.swing.ButtonGroup;
import javax.swing.ButtonModel;
import javax.swing.DefaultComboBoxModel;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFileChooser;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JRadioButton;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.JTextField;
import javax.swing.JViewport;
import javax.swing.ListCellRenderer;
import javax.swing.UIManager;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

//Ctrl + f for 'EDITED' to find the modified code areas 
public class OntologyBeanGeneratorPanel extends JPanel
{
	private static final long serialVersionUID = 1L;

	private static String getLaunchString(String document)
	{
		String launchString;

		if ((isWinNT()) || (isWin2000()))
		{
			launchString = "cmd /c start " + document;
		}
		else
		{
			if (isWin9X()) {
				launchString = "start " + document;
			} else {
				launchString = "explorer " + document;
			}
		}
		return launchString;
	}

	private static String getSystemProperty(String property)
	{
		String value;
		try
		{
			value = System.getProperty(property);
		}
		catch (SecurityException e)
		{

			value = "";
		}
		return value;
	}

	private static boolean isWin2000()
	{
		return getSystemProperty("os.name").indexOf("Windows 2000") != -1;
	}

	private static boolean isWin95()
	{
		return getSystemProperty("os.name").indexOf("Windows 95") != -1;
	}

	private static boolean isWin98()
	{
		return getSystemProperty("os.name").indexOf("Windows 98") != -1;
	}

	private static boolean isWin9X()
	{
		return (isWin95()) || (isWin98());
	}

	private static boolean isWinNT()
	{
		return getSystemProperty("os.name").indexOf("Windows NT") != -1;
	}

	private static boolean isWindows()
	{
		return (isWinNT()) || (isWin95()) || (isWin98()) || (isWin2000());
	}

	private void acklin_mouseClicked(MouseEvent e)
	{
		showHTML("http://www.acklin.nl");
	}

	private void acklin_mouseEntered(MouseEvent e) {}

	private void acklin_mouseExited(MouseEvent e) {}

	private void fillComboBoxModels()
	{
		this.locationComboBox.setModel(this.locationBoxModel);
		this.locationComboBox.setRenderer(new SomeLabelRenderer());
		this.locationComboBox.setBackground(Color.white);

		this.packageComboBox.setModel(this.packageBoxModel);
		this.packageComboBox.setRenderer(new SomeLabelRenderer());
		this.packageComboBox.setBackground(Color.white);

		this.ontologyComboBox.setModel(this.ontologyBoxModel);
		this.ontologyComboBox.setRenderer(new SomeLabelRenderer());
		this.ontologyComboBox.setBackground(Color.white);

		this.factoryComboBox.setModel(this.factoryBoxModel);
		this.factoryComboBox.setRenderer(new SomeLabelRenderer());
		this.factoryComboBox.setBackground(Color.white);

		Properties p = new Properties();
		String propFile = getPropertiesFile();
		try
		{
			p.load(new FileInputStream(new File(propFile)));
		}
		catch (Exception ex)
		{
			Log.getLogger().warning("The beangenerator.properties was not found. Path:" + propFile);
			return;
		}
		String key = "location";
		String value = "";
		int i = 1;
		while (i < 6)
		{
			value = p.getProperty(key + i);
			if (value != null) {
				this.locationBoxModel.addElement(value);
			}
			i++;
		}
		if (this.locationBoxModel.getSize() > 0) {
			this.locationComboBox.setSelectedIndex(0);
		}
		key = "package";
		value = "";
		i = 1;
		while (i < 6)
		{
			value = p.getProperty(key + i);
			if (value != null) {
				this.packageBoxModel.addElement(value);
			}
			i++;
		}
		if (this.packageBoxModel.getSize() > 0) {
			this.packageComboBox.setSelectedIndex(0);
		}
		key = "ontology";
		value = "";
		i = 1;
		while (i < 6)
		{
			value = p.getProperty(key + i);
			if (value != null) {
				this.ontologyBoxModel.addElement(value);
			}
			i++;
		}
		if (this.ontologyBoxModel.getSize() > 0) {
			this.ontologyComboBox.setSelectedIndex(0);
		}
		key = "factory";
		value = "";
		i = 1;
		while (i < 6)
		{
			value = p.getProperty(key + i);
			if (value != null) {
				this.factoryBoxModel.addElement(value);
			}
			i++;
		}
		if (this.factoryBoxModel.getSize() > 0) {
			this.factoryComboBox.setSelectedIndex(0);
		}
		value = p.getProperty("support");
		if ((value != null) && (value.equalsIgnoreCase("j2me"))) {
			this.support.setSelected(this.microSupport.getModel(), true);
		} else if ((value != null) && (value.equalsIgnoreCase("j2se"))) {
			this.support.setSelected(this.standardSupport.getModel(), true);
		} else if ((value != null) && (value.equalsIgnoreCase("javabeans"))) {
			this.support.setSelected(this.fullBeanSupport.getModel(), true);
		} else {
			this.support.setSelected(this.standardSupport.getModel(), true);
		}
		value = p.getProperty("createFactory");
		if ((value != null) && (value.equalsIgnoreCase("true"))) {
			this.factoryCheckBox.setSelected(true);
		} else {
			this.factoryCheckBox.setSelected(false);
		}
		value = p.getProperty("jalopy");
		if (value != null)
		{
			this.doFormatting.getModel().setSelected(true);
			this.jalopyFile.setText(value);
		}
		else
		{
			this.doFormatting.getModel().setSelected(false);
			this.jalopyFile.setText("");
		}
	}

	void fullBeanSupport_stateChanged(ChangeEvent e)
	{
		if (this.fullBeanSupport.isSelected())
		{
			this.exampleTextArea.setText(Examples.getFullExample());
			this.exampleTextArea.setCaretPosition(0);
		}
	}

	//EDITED: I want to skip multiple generate button presses
	private boolean stopGenerateButton = false;
	private void itsGenerateButton_actionPerformed(ActionEvent e)
	{
		if(!stopGenerateButton) {
			stopGenerateButton = true;
			this.statusTextArea.setText("");

			Thread processor = 
					new Thread()
			{
				public void run()
				{
					OntologyBeanGeneratorPanel.this.addSelectedItemsToComboBoxLists();
					OntologyBeanGeneratorPanel.this.model.doIt();
					stopGenerateButton = false;
				}
			};
			processor.start();
		}
	}

	private void addSelectedItemsToComboBoxLists()
	{
		addElementToComboBox((String)this.locationComboBox.getSelectedItem(), this.locationBoxModel, this.locationComboBox);
		addElementToComboBox((String)this.ontologyComboBox.getSelectedItem(), this.ontologyBoxModel, this.ontologyComboBox);
		addElementToComboBox((String)this.packageComboBox.getSelectedItem(), this.packageBoxModel, this.packageComboBox);
		addElementToComboBox((String)this.factoryComboBox.getSelectedItem(), this.factoryBoxModel, this.factoryComboBox);
	}

	void itsLocateButton_actionPerformed(ActionEvent e)
	{
		try
		{
			this.thejFileChooser.setApproveButtonText("Select");
			this.thejFileChooser.setFileSelectionMode(1);
			String currFileName = (String)this.locationComboBox.getSelectedItem();
			if (currFileName == null) {
				currFileName = ".";
			}
			this.thejFileChooser.setCurrentDirectory(new File(currFileName));
			this.thejFileChooser.setSelectedFile(new File(currFileName));
			if (this.thejFileChooser.showOpenDialog(this) == 0)
			{
				File f = this.thejFileChooser.getSelectedFile();
				String theLocation = f != null ? f.getPath() : null;
				if (f != null) {
					this.locationComboBox.setSelectedItem(theLocation);
				}
			}
		}
		catch (Exception g)
		{
			g.printStackTrace();
		}
	}

	void itsOntologyNameButton_actionPerformed(ActionEvent e)
	{
		String projectName = this.model.getProject().getName();

		this.ontologyComboBox.setSelectedItem(projectName);
	}

	void itsPackageNameButton_actionPerformed(ActionEvent e)
	{
		String projectName = this.model.getProject().getName();
		if (projectName == null) {
			projectName = "noName";
		}
		projectName = projectName.toLowerCase() + ".ontology";
		this.packageComboBox.setSelectedItem(projectName);
	}

	void addElementToComboBox(String name, DefaultComboBoxModel cmbxModel, JComboBox cmbx)
	{
		if ((name == null) || (name.equals(""))) {
			return;
		}
		ItemListener[] listeners = cmbx.getItemListeners();
		for (ItemListener aListener : listeners) {
			cmbx.removeItemListener(aListener);
		}
		if (cmbxModel.getIndexOf(name) != 0)
		{
			cmbxModel.removeElement(name);
			cmbxModel.insertElementAt(name, 0);
		}
		cmbx.setSelectedItem(name);
		for (ItemListener aListener : listeners) {
			cmbx.addItemListener(aListener);
		}
	}

	@SuppressWarnings("deprecation")
	void jbInit() throws Exception
	{
//		setLayout(new BorderLayout());
//		JavaMethodMapperPanel javaMethodMapperPanel = new JavaMethodMapperPanel(this.model.getProject());
//		javaMethodMapperPanel.initClassBrowserPanel();
//		add(javaMethodMapperPanel, BorderLayout.CENTER);
		
		this.acklin.setIcon(this.acklinIcon);
		this.acklin.setToolTipText("http://www.acklin.nl");
		this.acklin.addMouseListener(
				new MouseAdapter()
				{
					public void mouseClicked(MouseEvent e)
					{
						OntologyBeanGeneratorPanel.this.acklin_mouseClicked(e);
					}

					public void mouseEntered(MouseEvent e)
					{
						OntologyBeanGeneratorPanel.this.acklin_mouseEntered(e);
					}

					public void mouseExited(MouseEvent e)
					{
						OntologyBeanGeneratorPanel.this.acklin_mouseExited(e);
					}
				});
		this.titledBorder1 = new TitledBorder(BorderFactory.createLineBorder(Color.black, 1), "status:");
		setLayout(this.gridBagLayout1);
		this.rightPanel.setBackground(Color.white);
		this.rightPanel.addMouseListener(
				new MouseAdapter()
				{
					public void mouseExited(MouseEvent e)
					{
						OntologyBeanGeneratorPanel.this.rightPanel_mouseExited(e);
					}
				});
		this.rightPanel.setLayout(this.gridBagLayout2);
		this.jLabel1.setText("package name (e.g. mypackage.onto)");
		this.jLabel2.setText("location excl. package (e.g. /home/chris/projects/myproject/src/)");
		//EDITED
		//this.jLabel12.setText("name of the instance-bean factory class (e.g. " + OntologyBeanGeneratorTab.DEFAULT_FACTORY_CLASS_NAME + ")");
		// DANY
		// this.jLabel12.setText("classes to export into prolog separated by ';' (e.g. C1;C2;...;Cn)");
		this.itsLocateButton.setBackground(Color.white);
		this.itsLocateButton.setToolTipText("select a directory");
		this.itsLocateButton.setText("...");
		this.itsLocateButton.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						OntologyBeanGeneratorPanel.this.itsLocateButton_actionPerformed(e);
					}
				});
		this.jLabel3.setFont(new Font("Dialog", 0, 12));
		this.jLabel3.setForeground(Color.RED);
		this.jLabel3.setText("Warning!! This procedure will overwrite all existing files in the previous package!");
		this.jLabel4.setToolTipText("");
		this.jLabel4.setText("ontology domain (e.g. Newspaper)");
		this.jLabel5.setFont(new Font("Dialog", 1, 14));
		this.jLabel5.setForeground(Color.black);
		this.jLabel5.setToolTipText("<html><b>" + OntologyBeanGeneratorUtil.getVersionInformation() + "</b><html>");
		this.jLabel5.setHorizontalAlignment(0);
		//this.jLabel5.setText("Ontology Bean Generator for Jade 3.5");
		this.jLabel5.setText("Ontology Bean Generator 5.0 (for Jade 3.5)");
		this.jScrollPane1.setHorizontalScrollBarPolicy(32);
		this.jScrollPane1.setVerticalScrollBarPolicy(22);
		this.jScrollPane1.getViewport().setBackground(Color.white);
		this.jScrollPane1.setBorder(this.titledBorder1);
		this.jScrollPane1.setOpaque(false);
		this.statusTextArea.setEnabled(false);
		this.statusTextArea.setDisabledTextColor(Color.black);
		this.statusTextArea.setFont(new Font("Dialog", 0, 11));
		this.leftPanel.setLayout(this.gridBagLayout3);
		this.leftPanel.setBackground(UIManager.getColor("List.background"));
		this.jLabel6.setFont(new Font("Dialog", 0, 12));
		this.jLabel6.setForeground(Color.orange);
		this.jLabel6.setText("This directory will be created if it doesn't already exist");
		this.packageComboBox.setBackground(Color.white);
		this.packageComboBox.setFont(new Font("Dialog", 0, 11));
		this.packageComboBox.setEditable(true);
		this.locationComboBox.setBackground(Color.white);
		this.locationComboBox.setFont(new Font("Dialog", 0, 11));
		this.locationComboBox.setEditable(true);
		this.ontologyComboBox.setBackground(Color.white);
		this.ontologyComboBox.setFont(new Font("Dialog", 0, 11));
		this.ontologyComboBox.setEditable(true);
		this.factoryComboBox.setBackground(Color.white);
		this.factoryComboBox.setFont(new Font("Dialog", 0, 11));
		this.factoryComboBox.setEditable(true);
		//this.factoryComboBox.setEnabled(false);
		this.factoryComboBox.setEnabled(true);
		this.jLabel7.setToolTipText("package");
		this.jLabel7.setIcon(this.packageIcon);
		this.jLabel8.setToolTipText("location");
		this.jLabel8.setIcon(this.outputIcon);
		this.jLabel9.setToolTipText("ontology");
		this.jLabel9.setIcon(this.inboxIcon);
		//EDITED
		//this.jLabel13.setToolTipText("factory");
		// DANY
		// this.jLabel13.setToolTipText("prolog");
		//this.jLabel13.setIcon(this.factoryIcon);
		//this.uvaLabel.setToolTipText("http://www.swi.psy.uva.nl");
		this.uvaLabel.setIcon(this.uvaIcon);
		
		// DANY
		/*
		this.uvaLabel.addMouseListener(
				new MouseAdapter()
				{
					public void mouseClicked(MouseEvent e)
					{
						OntologyBeanGeneratorPanel.this.uvaLabel_mouseClicked(e);
					}

					public void mouseEntered(MouseEvent e)
					{
						OntologyBeanGeneratorPanel.this.uvaLabel_mouseEntered(e);
					}

					public void mouseExited(MouseEvent e)
					{
						OntologyBeanGeneratorPanel.this.uvaLabel_mouseExited(e);
					}
				});
		*/
		
		JPanel contributors = new JPanel();
		contributors.setLayout(new FlowLayout(1));
		contributors.setBackground(Color.white);
		this.jLabel10.setFont(new Font("Dialog", 0, 11));
		this.jLabel10.setText("progress");
		this.itsGenerateButton.setBackground(Color.white);
		this.itsGenerateButton.setForeground(Color.blue);
		this.itsGenerateButton.setToolTipText("Generate beans and optional jade ontology file");
		this.itsGenerateButton.setIcon(this.executeIcon);
		this.itsGenerateButton.setText("Generate Beans");
		
		this.itsGenerateButton.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						OntologyBeanGeneratorPanel.this.itsGenerateButton_actionPerformed(e);
					}
				});
		this.jPanel2.setBackground(Color.white);
		// DANY
		this.jPanel2.setLayout(this.gridBagLayout5);
		
		this.jPanel1.setBackground(Color.white);
		this.jPanel1.setLayout(this.gridBagLayout4);
		this.itsPackageNameButton.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						OntologyBeanGeneratorPanel.this.itsPackageNameButton_actionPerformed(e);
					}
				});
		this.itsPackageNameButton.setText("...");
		this.itsPackageNameButton.setToolTipText("use name of project");
		this.itsPackageNameButton.setBackground(Color.white);
		this.itsOntologyNameButton.setBackground(Color.white);
		this.itsOntologyNameButton.setToolTipText("use name of project");
		this.itsOntologyNameButton.setText("...");
		this.itsOntologyNameButton.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						OntologyBeanGeneratorPanel.this.itsOntologyNameButton_actionPerformed(e);
					}
				});
		
		// DANY
		/*
		this.itsFactoryNameButton.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						OntologyBeanGeneratorPanel.this.factoryComboBox.setSelectedItem(OntologyBeanGeneratorTab.DEFAULT_FACTORY_CLASS_NAME);
					}
				});
		*/
		
		// DANY
		// this.itsFactoryNameButton.setText("...");
		// this.itsFactoryNameButton.setToolTipText("use default factory class name");
		// this.itsFactoryNameButton.setBackground(Color.white);
		this.jLabel11.setFont(new Font("Dialog", 0, 11));
		this.jLabel11.setText("example:");
		this.exampleTextArea.setEditable(false);
		this.exampleTextArea.setFont(new Font("Courier", 0, 11));
		this.fullBeanSupport.addChangeListener(
				new ChangeListener()
				{
					public void stateChanged(ChangeEvent e)
					{
						OntologyBeanGeneratorPanel.this.fullBeanSupport_stateChanged(e);
					}
				});
		this.standardSupport.addChangeListener(
				new ChangeListener()
				{
					public void stateChanged(ChangeEvent e)
					{
						OntologyBeanGeneratorPanel.this.standardSupport_stateChanged(e);
					}
				});
		this.microSupport.addChangeListener(
				new ChangeListener()
				{
					public void stateChanged(ChangeEvent e)
					{
						OntologyBeanGeneratorPanel.this.microSupport_stateChanged(e);
					}
				});
		contributors.add(this.uvaLabel);
		contributors.add(this.acklin);
		contributors.add(this.mleLabel);
		contributors.add(this.jadeLabel);

		this.rightPanel.add(this.itsOntologyNameButton, new GridBagConstraints(4, 7, 1, 1, 0.0D, 0.0D, 
				12, 0, new Insets(0, 0, 0, 0), 0, 0));
		this.rightPanel.add(this.itsPackageNameButton, new GridBagConstraints(4, 2, 1, 2, 0.0D, 0.0D, 
				11, 0, new Insets(0, 0, 0, 0), 0, 0));
		// DANY
		// this.rightPanel.add(this.itsFactoryNameButton, new GridBagConstraints(4, 9, 1, 2, 0.0D, 0.0D, 
		//		11, 0, new Insets(0, 0, 0, 0), 0, 0));
		this.rightPanel.add(this.jPanel1, new GridBagConstraints(1, 13, 1, 10, 1.0D, 1.0D, 
				10, 1, new Insets(0, 5, 0, 5), 0, 0));
		this.jPanel1.add(this.jLabel11, new GridBagConstraints(0, 0, 1, 1, 0.0D, 0.0D, 
				10, 0, new Insets(0, 0, 0, 0), 0, 0));
		this.jPanel1.add(this.jScrollPane2, new GridBagConstraints(0, 1, 1, 1, 1.0D, 1.0D, 
				10, 1, new Insets(0, 0, 0, 0), 0, 0));
		this.jScrollPane2.getViewport().add(this.exampleTextArea, null);
		
		// DANY
		this.jPanel2.add(this.jLabel3, new GridBagConstraints(1, 1, 3, 1, 0.0D, 0.0D, 
				 13, 0, new Insets(0, 0, 0, 0), 0, 0));
		
		this.rightPanel.add(this.itsGenerateButton, new GridBagConstraints(0, 12, 5, 1, 0.0D, 0.0D, 
				11, 2, new Insets(5, 400, 5, 400), 1, 0));
		
		this.rightPanel.add(this.jPanel2, new GridBagConstraints(0, 11, 5, 1, 0.0D, 0.0D, 
				10, 2, new Insets(0, 0, 0, 0), 1, 0));
		
		this.rightPanel.add(this.jalopyFileLocator, new GridBagConstraints(3, 17, 1, 1, 0.0D, 0.0D, 
				14, 0, new Insets(0, 0, 0, 0), 0, 0));


		this.mleLabel.setIcon(this.mleIcon);
		// DANY
		/*
		this.mleLabel.setToolTipText("");
		this.mleLabel.addMouseListener(
				new MouseAdapter()
				{
					public void mouseClicked(MouseEvent e)
					{
						// DANY
						OntologyBeanGeneratorPanel.this.showHTML("");
					}
				});
		*/
		this.jadeCheckBox.setSelected(true);
		this.jadeCheckBox.setText("generate jade ontology file");
		this.jadeCheckBox.setToolTipText("Generate the Ontology file");
		this.jadeCheckBox.setBackground(Color.white);
		this.beansCheckBox.setSelected(true);
		this.beansCheckBox.setText("generate beans");
		this.beansCheckBox.setToolTipText("Generate the bean classes");
		this.beansCheckBox.setBackground(Color.white);
		this.useJadeNamesCheckBox.setSelected(false);
		this.useJadeNamesCheckBox.setText("use JADE names when specified");
		this.useJadeNamesCheckBox.setToolTipText("Use the \"JADE Name\" field specified in Protege");
		this.useJadeNamesCheckBox.setBackground(Color.white);
		this.useJadeNamesCheckBox.setEnabled(false);

		//EDITED
		// DANY
		/*
		this.factoryCheckBox.setSelected(true);
		//this.factoryCheckBox.setText("generate bean instance factory");
		this.factoryCheckBox.setText("generate prolog sub-classes");
		//this.factoryCheckBox.setToolTipText("Generate a factory class, which can create from Protege instances Java instances of the bean classes");
		this.factoryCheckBox.setToolTipText("Generate prolog sub-classes");
		this.factoryCheckBox.setBackground(Color.white);
		*/
	  //EDITED
		// DANY
		/*
		this.factoryCheckBox.getModel().addChangeListener(
				new ChangeListener()
				{
					public void stateChanged(ChangeEvent e)
					{
						boolean selected = OntologyBeanGeneratorPanel.this.factoryCheckBox.isSelected();
						OntologyBeanGeneratorPanel.this.jLabel12.setEnabled(selected);
						OntologyBeanGeneratorPanel.this.jLabel13.setEnabled(selected);
						OntologyBeanGeneratorPanel.this.factoryComboBox.setEnabled(selected);
						OntologyBeanGeneratorPanel.this.itsFactoryNameButton.setEnabled(selected);
					}
				});
		*/
		//EDITED
//		this.factoryCheckBox.doClick();
//		this.factoryCheckBox.setSelected(false);
//		this.factoryCheckBox.setEnabled(false);
		
		this.microSupport.setSelected(false);
		this.microSupport.setText("J2ME compatible [JADE-LEAP]");
		this.microSupport.setToolTipText(
				"Compatible with the Java 2 Micro Edition and the jade.content.onto.MicroIntrospector");
		this.microSupport.setBackground(Color.white);
		this.microSupport.setEnabled(false);


		this.fullBeanSupport.setSelected(false);
		this.fullBeanSupport.setText("J2SE JavaBean compatible [JADE]");
		this.fullBeanSupport.setToolTipText("Compatible with the JavaBeans specification");
		this.fullBeanSupport.setBackground(Color.white);
		this.fullBeanSupport.setEnabled(false);

		this.standardSupport.setSelected(false);
		this.standardSupport.setText("J2SE and Java 1.1 compatible [JADE, JADE-LEAP]");
		this.standardSupport.setToolTipText("Compatible with Java 2 or Java 1.1");
		this.standardSupport.setBackground(Color.white);

		
		this.support.add(this.fullBeanSupport);
		this.support.add(this.standardSupport);
		this.support.add(this.microSupport);
		this.support.setSelected(this.standardSupport.getModel(), true);


		this.jalopyFile.setVisible(false);
		this.doFormatting.setVisible(false);

		this.doFormatting.setText("Apply formatting");
		this.doFormatting.setBackground(Color.white);
		this.doFormatting.getModel().addChangeListener(
				new ChangeListener()
				{
					public void stateChanged(ChangeEvent e)
					{
						OntologyBeanGeneratorPanel.this.jalopyFile.setEnabled(OntologyBeanGeneratorPanel.this.doFormatting.isSelected());
					}
				});
		this.jalopyFile.setColumns(25);
		this.jalopyFileLocator.setBackground(Color.white);
		this.jalopyFileLocator.setToolTipText("select a directory");
		this.jalopyFileLocator.setText("...");
		this.jalopyFileLocator.setVisible(false);
		this.jalopyFileLocator.addActionListener(
				new ActionListener()
				{
					public void actionPerformed(ActionEvent e)
					{
						try
						{
							OntologyBeanGeneratorPanel.this.thejFileChooser.setApproveButtonText("Select");
							OntologyBeanGeneratorPanel.this.thejFileChooser.setFileSelectionMode(0);
							OntologyBeanGeneratorPanel.this.thejFileChooser.setSelectedFile(new File(OntologyBeanGeneratorPanel.this.jalopyFile.getText()));
							OntologyBeanGeneratorPanel.this.thejFileChooser.showOpenDialog(OntologyBeanGeneratorPanel.this);

							File f = OntologyBeanGeneratorPanel.this.thejFileChooser.getSelectedFile();

							OntologyBeanGeneratorPanel.this.jalopyFile.setText(f.getPath());
						}
						catch (Exception g)
						{
							g.printStackTrace();
						}
					}
				});
		this.jadeLabel.setIcon(this.jadeIcon);
//EDITED
/*******************************************************************************************************/		
		setLayout(new BorderLayout());
   	add(tabbedPane, BorderLayout.CENTER);
		tabbedPane.addTab("Ontology Bean Generator", null, this.mainSplitPane, "");
		
		JavaMethodMapperPanel javaMethodMapperPanel = new JavaMethodMapperPanel(model.getProject(), this.model);
		javaMethodMapperPanel.initClassBrowserPanel();
		tabbedPane.addTab("Java Method Mapper", null, javaMethodMapperPanel, "");
		
//		tabbedPane.addChangeListener(new ChangeListener() {
//			public void stateChanged(ChangeEvent e) {
//				if(tabbedPane.getSelectedIndex() == 1) {
//					((JavaMethodMapperPanel) tabbedPane.getSelectedComponent()).refreshOnClassHierarchyChange();
//				}
//			}
//		});
/*******************************************************************************************************/		
	
//		add(this.mainSplitPane, 
//				new GridBagConstraints(0, 1, 1, 1, 1.0D, 1.0D, 10, 
//						1, new Insets(0, 0, 0, 0), 0, 0));
		
/*******************************************************************************************************/		
//		setLayout(new BorderLayout());
//		add(this.outerSplitPane, BorderLayout.CENTER);
//		this.outerSplitPane.setRightComponent(this.mainSplitPane);
//		
//		JavaMethodMapperPanel javaMethodMapperPanel = new JavaMethodMapperPanel(model.getProject());
//		javaMethodMapperPanel.initClassBrowserPanel();
//		this.mainSplitPane.setLeftComponent(javaMethodMapperPanel);
//		this.outerSplitPane.setLeftComponent(javaMethodMapperPanel);
/*******************************************************************************************************/		

		this.mainSplitPane.setRightComponent(this.rightPanel);
		this.mainSplitPane.setLeftComponent(this.leftPanel);
		this.rightPanel.add(this.jLabel1, new GridBagConstraints(1, 1, 3, 1, 0.0D, 0.0D, 
				10, 0, new Insets(5, 0, 0, 0), 0, 0));
		this.rightPanel.add(this.jLabel2, new GridBagConstraints(1, 3, 3, 1, 0.0D, 0.0D, 
				10, 0, new Insets(10, 0, 0, 0), 0, 0));
		// DANY (moved later on)
		// this.rightPanel.add(this.jLabel3, new GridBagConstraints(1, 10, 3, 1, 0.0D, 0.0D, 
		//		13, 0, new Insets(0, 0, 0, 0), 0, 0));
		this.rightPanel.add(this.jLabel4, new GridBagConstraints(1, 6, 3, 1, 0.0D, 0.0D, 
				10, 0, new Insets(10, 0, 0, 0), 0, 0));
		// DANY
		//this.rightPanel.add(this.jLabel12, new GridBagConstraints(1, 8, 3, 1, 0.0D, 0.0D, 
		//		10, 0, new Insets(10, 0, 0, 0), 0, 0));
		this.rightPanel.add(this.jLabel5, new GridBagConstraints(1, 0, 5, 1, 1.0D, 0.0D, 
				10, 2, new Insets(10, 0, 10, 0), 0, 0));
		this.rightPanel.add(this.jLabel6, new GridBagConstraints(1, 4, 3, 1, 0.0D, 0.0D, 
				10, 0, new Insets(0, 0, 0, 0), 0, 0));
		this.rightPanel.add(this.packageComboBox, new GridBagConstraints(1, 2, 3, 1, 1.0D, 0.0D, 
				10, 2, new Insets(0, 0, 0, 5), 0, 0));
		this.rightPanel.add(this.locationComboBox, new GridBagConstraints(1, 5, 3, 1, 1.0D, 0.0D, 
				10, 2, new Insets(0, 0, 0, 5), 0, 0));
		this.rightPanel.add(this.ontologyComboBox, new GridBagConstraints(1, 7, 3, 1, 1.0D, 0.0D, 
				10, 2, new Insets(0, 0, 0, 5), 0, 0));
		
		// DANY
		// this.rightPanel.add(this.factoryComboBox, new GridBagConstraints(1, 9, 3, 1, 1.0D, 0.0D, 
		//		10, 2, new Insets(0, 0, 0, 5), 0, 0));
		this.rightPanel.add(this.jLabel7, new GridBagConstraints(0, 2, 1, 1, 0.0D, 0.0D, 
				10, 0, new Insets(0, 5, 0, 5), 0, 0));
		this.rightPanel.add(this.jLabel8, new GridBagConstraints(0, 5, 1, 1, 0.0D, 0.0D, 
				10, 0, new Insets(0, 5, 0, 5), 0, 0));
		this.rightPanel.add(this.jLabel9, new GridBagConstraints(0, 7, 1, 1, 0.0D, 0.0D, 
				10, 0, new Insets(0, 5, 0, 5), 0, 0));
		// DANY
		//this.rightPanel.add(this.jLabel13, new GridBagConstraints(0, 9, 1, 1, 0.0D, 0.0D, 
		//		10, 0, new Insets(0, 5, 0, 5), 0, 0));
		this.rightPanel.add(this.itsLocateButton, new GridBagConstraints(4, 5, 1, 1, 0.0D, 0.0D, 
				17, 0, new Insets(0, 0, 0, 0), 0, 0));

		this.rightPanel.add(this.jadeCheckBox, new GridBagConstraints(2, 13, 1, 1, 0.0D, 0.0D, 
				16, 0, new Insets(15, 0, 0, 0), 0, 0));
		this.rightPanel.add(this.beansCheckBox, new GridBagConstraints(2, 14, 1, 1, 0.0D, 0.0D, 
				16, 0, new Insets(0, 0, 0, 0), 0, 0));

		this.rightPanel.add(this.useJadeNamesCheckBox, new GridBagConstraints(2, 15, 1, 1, 0.0D, 0.0D, 
				16, 0, new Insets(0, 0, 0, 0), 0, 0));

		// DANY
		// this.rightPanel.add(this.factoryCheckBox, new GridBagConstraints(2, 16, 1, 1, 0.0D, 0.0D, 
		//		16, 0, new Insets(0, 0, 0, 0), 0, 0));

		this.rightPanel.add(this.doFormatting, new GridBagConstraints(2, 17, 1, 1, 0.0D, 0.0D, 
				16, 0, new Insets(0, 0, 0, 0), 0, 0));

		this.rightPanel.add(this.jalopyFile, new GridBagConstraints(2, 18, 1, 1, 0.0D, 0.0D, 
				16, 0, new Insets(0, 0, 0, 0), 0, 0));


		this.rightPanel.add(this.fullBeanSupport, new GridBagConstraints(2, 20, 1, 1, 0.0D, 0.0D, 
				16, 0, new Insets(15, 0, 0, 0), 0, 0));
		this.rightPanel.add(this.standardSupport, new GridBagConstraints(2, 21, 1, 1, 0.0D, 0.0D, 
				16, 0, new Insets(0, 0, 0, 0), 0, 0));
		this.rightPanel.add(this.microSupport, new GridBagConstraints(2, 22, 1, 1, 0.0D, 0.0D, 
				18, 0, new Insets(0, 0, 0, 0), 0, 0));

		this.rightPanel.add(contributors, new GridBagConstraints(0, 24, 4, 1, 0.0D, 0.0D, 
				10, 0, new Insets(20, 0, 0, 0), 0, 0));

		this.mainSplitPane.setDividerLocation(200);
		this.leftPanel.add(this.jScrollPane1, new GridBagConstraints(0, 0, 2, 1, 1.0D, 1.0D, 
				10, 1, new Insets(0, 0, 0, 0), 0, 0));
		this.leftPanel.add(this.progress, new GridBagConstraints(1, 1, 1, 1, 1.0D, 0.0D, 
				10, 2, new Insets(0, 0, 0, 0), 0, 0));
		this.leftPanel.add(this.jLabel10, new GridBagConstraints(0, 1, 1, 1, 0.0D, 0.0D, 
				10, 0, new Insets(0, 0, 0, 0), 0, 0));
		this.jScrollPane1.getViewport().add(this.statusTextArea, null);


	}

	void microSupport_stateChanged(ChangeEvent e)
	{
		if (this.microSupport.isSelected())
		{
			this.exampleTextArea.setText(Examples.getMicroExample());
			this.exampleTextArea.setCaretPosition(0);
		}
	}

	private void rightPanel_mouseExited(MouseEvent e) {}

	private void showHTML(String url)
	{
		WaitCursor wait = new WaitCursor(this);
		String command = getLaunchString(url);
		try
		{
			Runtime.getRuntime().exec(command);
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
		wait.hide();
	}

	void standardSupport_stateChanged(ChangeEvent e)
	{
		if (this.standardSupport.isSelected())
		{
			this.exampleTextArea.setText(Examples.getStandardExample());
			this.exampleTextArea.setCaretPosition(0);
		}
	}

	private void uvaLabel_mouseClicked(MouseEvent e)
	{
		showHTML("http://www.swi.psy.uva.nl");
	}

	private void uvaLabel_mouseEntered(MouseEvent e) {}

	private void uvaLabel_mouseExited(MouseEvent e) {}

	public OntologyBeanGeneratorPanel(OntologyBeanGeneratorTab model)
	{
		try
		{
			this.model = model;
			jbInit();
			fillComboBoxModels();
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
	}

	private JLabel acklin = new JLabel();
	private ImageIcon acklinIcon = new ImageIcon(getClass().getResource("graphics/acklin.jpg"));
	JCheckBox beansCheckBox = new JCheckBox();
	JCheckBox doFormatting = new JCheckBox();
	public JTextArea exampleTextArea = new JTextArea();
	private ImageIcon executeIcon = new ImageIcon(
			getClass().getResource("graphics/execute.gif"));
	public JRadioButton fullBeanSupport = new JRadioButton();
	GridBagLayout gridBagLayout1 = new GridBagLayout();
	GridBagLayout gridBagLayout2 = new GridBagLayout();
	GridBagLayout gridBagLayout3 = new GridBagLayout();
	GridBagLayout gridBagLayout4 = new GridBagLayout();
	// DANY
	GridBagLayout gridBagLayout5 = new GridBagLayout();
	
	private ImageIcon inboxIcon = new ImageIcon(getClass().getResource("graphics/inbox.gif"));
	JButton itsGenerateButton = new JButton();
	JButton itsLocateButton = new JButton();
	JButton itsOntologyNameButton = new JButton();
	JButton itsPackageNameButton = new JButton();
	JButton itsFactoryNameButton = new JButton();
	JLabel jLabel1 = new JLabel();
	JLabel jLabel10 = new JLabel();
	JLabel jLabel11 = new JLabel();
	JLabel jLabel12 = new JLabel();
	JLabel jLabel13 = new JLabel();
	JLabel jLabel2 = new JLabel();
	JLabel jLabel3 = new JLabel();
	JLabel jLabel4 = new JLabel();
	JLabel jLabel5 = new JLabel();
	JLabel jLabel6 = new JLabel();
	private JLabel jLabel7 = new JLabel();
	private JLabel jLabel8 = new JLabel();
	private JLabel jLabel9 = new JLabel();
	JPanel jPanel1 = new JPanel();
	JPanel jPanel2 = new JPanel();
	JScrollPane jScrollPane1 = new JScrollPane();
	JScrollPane jScrollPane2 = new JScrollPane();
	JCheckBox jadeCheckBox = new JCheckBox();
	private ImageIcon jadeIcon = new ImageIcon(getClass().getResource("graphics/jadelogo.gif"));
	private JLabel jadeLabel = new JLabel();
	JTextField jalopyFile = new JTextField();
	JButton jalopyFileLocator = new JButton();
	JButton jalopyPreferences = new JButton();
	JPanel leftPanel = new JPanel();
	public DefaultComboBoxModel locationBoxModel = new DefaultComboBoxModel();
	JComboBox locationComboBox = new JComboBox();
	JSplitPane mainSplitPane = new JSplitPane();
	//JSplitPane outerSplitPane = new JSplitPane();
	JTabbedPane tabbedPane = new JTabbedPane();
	public JRadioButton microSupport = new JRadioButton();
	private ImageIcon mleIcon = new ImageIcon(getClass().getResource("graphics/mle.gif"));
	JLabel mleLabel = new JLabel();
	private OntologyBeanGeneratorTab model;
	public DefaultComboBoxModel ontologyBoxModel = new DefaultComboBoxModel();
	JComboBox ontologyComboBox = new JComboBox();
	private ImageIcon outputIcon = new ImageIcon(getClass().getResource("graphics/output.gif"));
	public DefaultComboBoxModel packageBoxModel = new DefaultComboBoxModel();
	JComboBox packageComboBox = new JComboBox();
	private ImageIcon packageIcon = new ImageIcon(
			getClass().getResource("graphics/package.gif"));
	public DefaultComboBoxModel factoryBoxModel = new DefaultComboBoxModel();
	JComboBox factoryComboBox = new JComboBox();
	//EDITED
	//private ImageIcon factoryIcon = new ImageIcon(getClass().getResource("graphics/factory.gif"));
	JProgressBar progress = new JProgressBar(0);
	JPanel rightPanel = new JPanel();
	public JRadioButton standardSupport = new JRadioButton();
	JTextArea statusTextArea = new JTextArea();
	public ButtonGroup support = new ButtonGroup();
	JFileChooser thejFileChooser = new JFileChooser();
	private TitledBorder titledBorder1;
	JCheckBox useJadeNamesCheckBox = new JCheckBox();
	JCheckBox factoryCheckBox = new JCheckBox();
	private ImageIcon uvaIcon = new ImageIcon(getClass().getResource("graphics/uva.gif"));
	private JLabel uvaLabel = new JLabel();

	private class SomeLabelRenderer
	extends JLabel
	implements ListCellRenderer
	{
		private static final long serialVersionUID = 1L;

		public Component getListCellRendererComponent(JList list, Object value, int index, boolean isSelected, boolean cellHasFocus)
		{
			if (value != null)
			{
				setText((String)value);


				setText((String)value);
			}
			setBackground(isSelected ? Color.blue : Color.white);
			setForeground(isSelected ? Color.white : Color.black);
			return this;
		}

		public SomeLabelRenderer()
		{
			setOpaque(true);
			setFont(new Font("Dialog", 0, 10));
		}
	}

	private String getPropertiesFile()
	{
		String propFile = "beangenerator.properties";

		File pluginDir = PluginUtilities.getInstallationDirectory("nl.uva.psy.swi.beangenerator.OntologyBeanGeneratorTab");
		if (pluginDir != null) {
			propFile = pluginDir.getAbsolutePath() + File.separator + propFile;
		}
		return propFile;
	}

	public void saveProperties()
	{
		Properties p = new Properties();
		String propFile = getPropertiesFile();

		String key = "location";
		String value = "";
		int i = 1;
		while (i <= this.locationBoxModel.getSize())
		{
			value = (String)this.locationBoxModel.getElementAt(i - 1);
			p.setProperty(key + i, value);
			i++;
		}
		key = "package";
		value = "";
		i = 1;
		while (i <= this.packageBoxModel.getSize())
		{
			value = (String)this.packageBoxModel.getElementAt(i - 1);
			p.setProperty(key + i, value);
			i++;
		}
		key = "ontology";
		value = "";
		i = 1;
		while (i <= this.ontologyBoxModel.getSize())
		{
			value = (String)this.ontologyBoxModel.getElementAt(i - 1);
			p.setProperty(key + i, value);
			i++;
		}
		key = "factory";
		value = "";
		i = 1;
		while (i <= this.factoryBoxModel.getSize())
		{
			value = (String)this.factoryBoxModel.getElementAt(i - 1);
			p.setProperty(key + i, value);
			i++;
		}
		if (this.support.isSelected(this.microSupport.getModel())) {
			value = "j2me";
		} else if (this.support.isSelected(this.standardSupport.getModel())) {
			value = "j2se";
		} else if (this.support.isSelected(this.fullBeanSupport.getModel())) {
			value = "javabeans";
		} else {
			value = "j2se";
		}
		p.setProperty("support", value);
		if (this.factoryCheckBox.isSelected()) {
			value = "true";
		} else {
			value = "false";
		}
		p.setProperty("createFactory", value);
		if (this.doFormatting.getModel().isSelected())
		{
			value = this.jalopyFile.getText();
			p.setProperty("jalopy", value);
		}
		try
		{
			p.store(new FileOutputStream(new File(propFile)), "");
		}
		catch (IOException ex)
		{
			Log.getLogger().warning("The beangenerator.properties could not be written. Path:" + propFile);
			return;
		}
	}
}



