  package nl.uva.psy.swi.beangenerator;
  
  import edu.stanford.smi.protege.model.Cls;
  import edu.stanford.smi.protege.model.Slot;
  import edu.stanford.smi.protege.model.ValueType;
  import java.text.SimpleDateFormat;
  import java.util.Collection;
  import java.util.Date;
  import java.util.Iterator;
  import java.util.Locale;
  
  public class OntologyBeanGeneratorUtil
  {
    public static String getVersionInformation()
    {
      //return "OntologyBeanGenerator v4.1";
    	return "OntologyBeanGenerator v5.0";
    }
    
    protected static String getJavaSlotType(ValueType valueType)
    {
      String theType = "";
      if (valueType.equals(ValueType.BOOLEAN)) {
        //return "boolean";
    	  return "Boolean";
      }
      if (valueType.equals(ValueType.CLS)) {
        return "Object";
      }
      if (valueType.equals(ValueType.FLOAT)) {
        return "Float";
      }
      if (valueType.equals(ValueType.INTEGER)) {
        //return "int";
    	  return "Integer";
      }
      if (valueType.equals(ValueType.STRING)) {
        return "String";
      }
      if (valueType.equals(ValueType.SYMBOL)) {
        return "String";
      }
      if (valueType.equals(ValueType.ANY)) {
        return "String";
      }
      if ((valueType.equals(ValueType.ANY)) || (valueType.equals(ValueType.SYMBOL))) {
        return "String";
      }
      theType = valueType.getJavaType().toString();
      theType = ProtegeTools.toJavaString(theType);
      theType = ProtegeTools.firstUpper(theType);
      return theType;
    }
    
    protected static String getDate()
    {
      SimpleDateFormat formatter = new SimpleDateFormat("yyyy/MM/d, HH:mm:ss", Locale.getDefault());
      Date currentDate = new Date();
      return formatter.format(currentDate);
    }
    
    protected static String getOntologyType(ValueType valueType)
    {
      String ontologyType = "";
      if (valueType.equals(ValueType.BOOLEAN)) {
        ontologyType = "BasicOntology.BOOLEAN";
      }
      if (valueType.equals(ValueType.CLS)) {
        ontologyType = "BasicOntology.SET";
      }
      if (valueType.equals(ValueType.FLOAT)) {
        ontologyType = "BasicOntology.FLOAT";
      }
      if (valueType.equals(ValueType.INTEGER)) {
        ontologyType = "BasicOntology.INTEGER";
      }
      if (valueType.equals(ValueType.STRING)) {
        ontologyType = "BasicOntology.STRING";
      }
      if (valueType.equals(ValueType.SYMBOL)) {
        ontologyType = "BasicOntology.STRING";
      }
      if (valueType.equals(ValueType.ANY)) {
        ontologyType = "BasicOntology.STRING";
      }
      return ontologyType;
    }
    
    protected static String getFacetString(Slot theSlot)
    {
      String str = "    // facets of " + theSlot.getName() + ": ";
      if ((theSlot.getValueType().equals(ValueType.INTEGER)) || (theSlot.getValueType().equals(ValueType.FLOAT)))
      {
        if (theSlot.getMinimumValue() != null) {
          str = str + "getMinimumValue " + theSlot.getMinimumValue() + ", ";
        }
        if (theSlot.getMaximumValue() != null) {
          str = str + "getMaximumValue " + theSlot.getMaximumValue() + ", ";
        }
      }
      if (theSlot.getAllowedValues().size() > 0)
      {
        if (theSlot.getMinimumCardinality() > 0) {
          str = str + "MinimumCardinality " + theSlot.getMinimumCardinality() + ",";
        }
        if (theSlot.getMaximumCardinality() > 0) {
          str = str + "MaximumCardinality " + theSlot.getMaximumCardinality() + ", ";
        }
      }
      if (theSlot.getAllowedClses().size() > 0)
      {
        str = str + "getAllowedClses: ";
        Iterator<?> it = theSlot.getAllowedClses().iterator();
        while (it.hasNext()) {
          str = str + (Cls)it.next() + ", ";
        }
      }
      if (theSlot.getAllowedParents().size() > 0)
      {
        str = str + ", getAllowedParents: ";
        Iterator<?> it = theSlot.getAllowedParents().iterator();
        while (it.hasNext()) {
          str = str + it.next().toString() + ", ";
        }
      }
      if (theSlot.getAllowedValues().size() > 0)
      {
        str = str + ", getAllowedValues: ";
        Iterator<?> it = theSlot.getAllowedValues().iterator();
        while (it.hasNext()) {
          str = str + it.next().toString() + ", ";
        }
      }
      return str;
    }
  }



 